import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:remove_app/remove_app.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  bool _uninstallPerformed;

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
   bool uninstallPerformed;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
      uninstallPerformed = await RemoveApp.Uninstall("com.frendyapp.uninstall_app");
    } on Exception {
      _uninstallPerformed = false;
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _uninstallPerformed = uninstallPerformed;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Text('Did user uninstall the app ?: $_uninstallPerformed\n'),
        ),
      ),
    );
  }
}
